diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index eeb4d9bd220..92985b937db 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -128,7 +128,6 @@ struct JoystickImpl
 	BYTE				buttons[KEY_MAX];
 
 	/* Force feedback variables */
-        struct list                     ff_effects;
 	int				ff_state;
 	int				ff_autocenter;
 	int				ff_gain;
@@ -164,12 +163,20 @@ static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value);
 static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value);
 
+static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
+        struct list *entry, IDirectInputEffect **out);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_acquire,
     unix_joystick_unacquire,
     unix_joystick_ff_set_autocenter,
     unix_joystick_ff_set_gain,
+#ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
+    unix_joystick_create_effect,
+#else
+    NULL,
+#endif
     unix_joystick_poll,
 };
 
@@ -459,7 +466,7 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
     newDevice->joyfd       = -1;
     newDevice->joydev = joydev;
     newDevice->generic.name        = newDevice->joydev->name;
-    list_init(&newDevice->ff_effects);
+    list_init(&newDevice->generic.ff_effects);
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     newDevice->ff_state    = FF_STATUS_STOPPED;
 #endif
@@ -867,63 +874,35 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 /****************************************************************************** 
   *	CreateEffect - Create a new FF effect with the specified params
   */
-static HRESULT WINAPI JoystickWImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid,
-                                                 LPCDIEFFECT lpeff, LPDIRECTINPUTEFFECT *ppdef,
-                                                 LPUNKNOWN pUnkOuter)
+static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
+        struct list *entry, IDirectInputEffect **out)
 {
-#ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
-    effect_list_item* new_effect = NULL;
     HRESULT retval = DI_OK;
-#endif
-
-    JoystickImpl* This = impl_from_IDirectInputDevice8W(iface);
-    TRACE("(this=%p,%p,%p,%p,%p)\n", This, rguid, lpeff, ppdef, pUnkOuter);
+    JoystickImpl* This = impl_from_unix_joystick(ptr);
+    TRACE("(this=%p,%p,%p,%p,%p)\n", This, guid, effect, entry, out);
 
-    *ppdef = NULL;
+    *out = NULL;
     if (!This->joydev->has_ff)
     {
         TRACE("No force feedback support\n");
         return DIERR_UNSUPPORTED;
     }
 
-#ifndef HAVE_STRUCT_FF_EFFECT_DIRECTION
-    TRACE("not available (compiled w/o force feedback support)\n");
-    return DIERR_UNSUPPORTED;
-#else
-
-    if (!(new_effect = HeapAlloc(GetProcessHeap(), 0, sizeof(*new_effect))))
-        return DIERR_OUTOFMEMORY;
+    retval = linuxinput_create_effect(&This->joyfd, guid, entry, out);
+    if (retval != DI_OK) return retval;
 
-    retval = linuxinput_create_effect(&This->joyfd, rguid, &new_effect->entry, &new_effect->ref);
-    if (retval != DI_OK)
+    if (effect != NULL)
     {
-        HeapFree(GetProcessHeap(), 0, new_effect);
-        return retval;
-    }
-
-    if (lpeff != NULL)
-    {
-        retval = IDirectInputEffect_SetParameters(new_effect->ref, lpeff,
+        retval = IDirectInputEffect_SetParameters(*out, effect,
             DIEP_AXES | DIEP_DIRECTION | DIEP_DURATION | DIEP_ENVELOPE |
             DIEP_GAIN | DIEP_SAMPLEPERIOD | DIEP_STARTDELAY | DIEP_TRIGGERBUTTON |
             DIEP_TRIGGERREPEATINTERVAL | DIEP_TYPESPECIFICPARAMS);
 
         if (retval != DI_OK && retval != DI_DOWNLOADSKIPPED)
-        {
-            HeapFree(GetProcessHeap(), 0, new_effect);
             return retval;
-        }
     }
 
-    list_add_tail(&This->ff_effects, &new_effect->entry);
-    *ppdef = new_effect->ref;
-
-    if (pUnkOuter != NULL)
-	FIXME("Interface aggregation not implemented.\n");
-
     return DI_OK;
-
-#endif /* HAVE_STRUCT_FF_EFFECT_DIRECTION */
 }
 
 /*******************************************************************************
@@ -1063,7 +1042,7 @@ static HRESULT WINAPI JoystickWImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE
         effect_list_item *itr;
 
         /* Stop all effects */
-        LIST_FOR_EACH_ENTRY(itr, &This->ff_effects, effect_list_item, entry)
+        LIST_FOR_EACH_ENTRY(itr, &This->generic.ff_effects, effect_list_item, entry)
             IDirectInputEffect_Stop(itr->ref);
         break;
     }
@@ -1073,7 +1052,7 @@ static HRESULT WINAPI JoystickWImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE
         effect_list_item *itr;
 
         /* Stop and unload all effects. It is not true that effects are released */
-        LIST_FOR_EACH_ENTRY(itr, &This->ff_effects, effect_list_item, entry)
+        LIST_FOR_EACH_ENTRY(itr, &This->generic.ff_effects, effect_list_item, entry)
         {
             IDirectInputEffect_Stop(itr->ref);
             IDirectInputEffect_Unload(itr->ref);
@@ -1100,32 +1079,6 @@ static HRESULT WINAPI JoystickWImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE
 #endif
 }
 
-/*******************************************************************************
- *      EnumCreatedEffectObjects - Enumerate all the effects that have been
- *		created for this device.
- */
-static HRESULT WINAPI JoystickWImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE8W iface,
-                                                             LPDIENUMCREATEDEFFECTOBJECTSCALLBACK lpCallback,
-                                                             LPVOID pvRef, DWORD dwFlags)
-{
-    /* this function is safe to call on non-ff-enabled builds */
-    JoystickImpl* This = impl_from_IDirectInputDevice8W(iface);
-    effect_list_item *itr, *ptr;
-
-    TRACE("(this=%p,%p,%p,%d)\n", This, lpCallback, pvRef, dwFlags);
-
-    if (!lpCallback)
-	return DIERR_INVALIDPARAM;
-
-    if (dwFlags != 0)
-	FIXME("Flags specified, but no flags exist yet (DX9)!\n");
-
-    LIST_FOR_EACH_ENTRY_SAFE(itr, ptr, &This->ff_effects, effect_list_item, entry)
-        (*lpCallback)(itr->ref, pvRef);
-
-    return DI_OK;
-}
-
 static const IDirectInputDevice8WVtbl JoystickWvt =
 {
     IDirectInputDevice2WImpl_QueryInterface,
@@ -1146,12 +1099,12 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_GetDeviceInfo,
     IDirectInputDevice2WImpl_RunControlPanel,
     IDirectInputDevice2WImpl_Initialize,
-    JoystickWImpl_CreateEffect,
+    JoystickWGenericImpl_CreateEffect,
     JoystickWImpl_EnumEffects,
     JoystickWImpl_GetEffectInfo,
     JoystickWImpl_GetForceFeedbackState,
     JoystickWImpl_SendForceFeedbackCommand,
-    JoystickWImpl_EnumCreatedEffectObjects,
+    JoystickWGenericImpl_EnumCreatedEffectObjects,
     IDirectInputDevice2WImpl_Escape,
     JoystickWGenericImpl_Poll,
     IDirectInputDevice2WImpl_SendDeviceData,
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index f129b666b2f..079063fd35f 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -110,7 +110,6 @@ struct JoystickImpl
     CFArrayRef             elements;
     ObjProps               **propmap;
     FFDeviceObjectReference ff;
-    struct list effects;
 };
 
 static inline JoystickImpl *impl_from_IDirectInputDevice8W(IDirectInputDevice8W *iface)
@@ -946,12 +945,16 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value);
 static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value);
 
+static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
+        struct list *entry, IDirectInputEffect **out);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     NULL,
     NULL,
     unix_joystick_ff_set_autocenter,
     unix_joystick_ff_set_gain,
+    unix_joystick_create_effect,
     unix_joystick_poll,
 };
 
@@ -1107,7 +1110,7 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
     newDevice->generic.name = HeapAlloc(GetProcessHeap(),0,strlen(name) + 1);
     strcpy(newDevice->generic.name, name);
 
-    list_init(&newDevice->effects);
+    list_init(&newDevice->generic.ff_effects);
     if(get_ff(device, &newDevice->ff) == S_OK){
         newDevice->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
 
@@ -1345,16 +1348,15 @@ static CFUUIDRef effect_win_to_mac(const GUID *effect)
     return 0;
 }
 
-static HRESULT WINAPI JoystickWImpl_CreateEffect(IDirectInputDevice8W *iface,
-        const GUID *type, const DIEFFECT *params, IDirectInputEffect **out,
-        IUnknown *outer)
+static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
+        struct list *entry, IDirectInputEffect **out)
 {
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
     EffectImpl *effect;
     HRESULT hr;
 
-    TRACE("(%p)->(%s %p %p %p)\n", This, debugstr_guid(type), params, out, outer);
-    dump_DIEFFECT(params, type, 0);
+    TRACE("(%p)->(%s %p %p %p)\n", This, debugstr_guid(guid), params, entry, out);
+    dump_DIEFFECT(params, guid, 0);
 
     if(!This->ff){
         TRACE("No force feedback support\n");
@@ -1362,25 +1364,21 @@ static HRESULT WINAPI JoystickWImpl_CreateEffect(IDirectInputDevice8W *iface,
         return DIERR_UNSUPPORTED;
     }
 
-    if(outer)
-        WARN("aggregation not implemented\n");
-
     effect = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*This));
     effect->IDirectInputEffect_iface.lpVtbl = &EffectVtbl;
     effect->ref = 1;
-    effect->guid = *type;
+    effect->guid = *guid;
     effect->device = This;
 
     /* Mac's FFEFFECT and Win's DIEFFECT are binary identical. */
     hr = osx_to_win32_hresult(FFDeviceCreateEffect(This->ff,
-                effect_win_to_mac(type), (FFEFFECT*)params, &effect->effect));
+                effect_win_to_mac(guid), (FFEFFECT*)params, &effect->effect));
     if(FAILED(hr)){
         WARN("FFDeviceCreateEffect failed: %08x\n", hr);
         HeapFree(GetProcessHeap(), 0, effect);
         return hr;
     }
 
-    list_add_tail(&This->effects, &effect->entry);
     *out = &effect->IDirectInputEffect_iface;
 
     TRACE("allocated effect: %p\n", effect);
@@ -1435,12 +1433,12 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_GetDeviceInfo,
     IDirectInputDevice2WImpl_RunControlPanel,
     IDirectInputDevice2WImpl_Initialize,
-    JoystickWImpl_CreateEffect,
+    JoystickWGenericImpl_CreateEffect,
     IDirectInputDevice2WImpl_EnumEffects,
     IDirectInputDevice2WImpl_GetEffectInfo,
     IDirectInputDevice2WImpl_GetForceFeedbackState,
     JoystickWImpl_SendForceFeedbackCommand,
-    IDirectInputDevice2WImpl_EnumCreatedEffectObjects,
+    JoystickWGenericImpl_EnumCreatedEffectObjects,
     IDirectInputDevice2WImpl_Escape,
     JoystickWGenericImpl_Poll,
     IDirectInputDevice2WImpl_SendDeviceData,
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index c7d1669fe1f..48ab9a42f38 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -43,6 +43,8 @@ struct unix_joystick_vtbl
     HRESULT (CDECL *ff_set_autocenter)(struct unix_joystick *ptr, DWORD value);
     HRESULT (CDECL *ff_set_gain)(struct unix_joystick *ptr, DWORD value);
 
+    HRESULT (CDECL *create_effect)(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect, struct list *entry, IDirectInputEffect **out);
+
     void (CDECL *poll)(struct unix_joystick *ptr);
 };
 
@@ -62,6 +64,7 @@ typedef struct JoystickGenericImpl
 
     DWORD ff_autocenter;
     DWORD ff_gain;
+    struct list ff_effects;
 } JoystickGenericImpl;
 
 LONG joystick_map_axis(ObjProps *props, int val) DECLSPEC_HIDDEN;
@@ -86,6 +89,12 @@ HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface) DECLSPE
 
 HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
 
+HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIEFFECT lpeff,
+        LPDIRECTINPUTEFFECT *ppdef, LPUNKNOWN pUnkOuter) DECLSPEC_HIDDEN;
+
+HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE8W iface,
+        LPDIENUMCREATEDEFFECTOBJECTSCALLBACK lpCallback, LPVOID pvRef, DWORD dwFlags) DECLSPEC_HIDDEN;
+
 HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface, DWORD len, LPVOID ptr) DECLSPEC_HIDDEN;
-- 
2.28.0

>From 77c13c2bf2cfe8ddf0b4cb453b1f301903afbbf8 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 23:29:20 +0200
Subject: [PATCH 18/39] dinput: Use the unix vtable for
 SendForceFeedbackCommand.

---
 dlls/dinput/joystick.c            | 30 ++++++++++++++++++++++++++
 dlls/dinput/joystick_linux.c      |  1 +
 dlls/dinput/joystick_linuxinput.c | 35 ++++++++-----------------------
 dlls/dinput/joystick_osx.c        |  9 ++++----
 dlls/dinput/joystick_private.h    |  3 +++
 5 files changed, 48 insertions(+), 30 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index d80dd7d5caf..05ed7f8da3d 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -779,6 +779,36 @@ HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE
     return DI_OK;
 }
 
+HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+    effect_list_item *itr;
+
+    TRACE("(this=%p,%d)\n", This, dwFlags);
+
+    if (!This->unix_funcs->create_effect) return DIERR_UNSUPPORTED;
+
+    switch (dwFlags)
+    {
+    case DISFFC_STOPALL:
+        LIST_FOR_EACH_ENTRY(itr, &This->ff_effects, effect_list_item, entry)
+            IDirectInputEffect_Stop(itr->ref);
+        break;
+    case DISFFC_RESET:
+        LIST_FOR_EACH_ENTRY(itr, &This->ff_effects, effect_list_item, entry)
+        {
+            IDirectInputEffect_Stop(itr->ref);
+            IDirectInputEffect_Unload(itr->ref);
+        }
+        break;
+    default:
+        break;
+    }
+
+    if (!This->unix_funcs->ff_send_cmd) return DI_OK;
+    return This->unix_funcs->ff_send_cmd(This->unix_ptr, dwFlags);
+}
+
 HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 615d9432718..5220cb2cf5e 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -145,6 +145,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     NULL,
     NULL,
     NULL,
+    NULL,
     unix_joystick_poll,
 };
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 92985b937db..d2075099ac0 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -162,6 +162,7 @@ static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value);
 static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value);
+static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD flags);
 
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
         struct list *entry, IDirectInputEffect **out);
@@ -172,6 +173,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     unix_joystick_unacquire,
     unix_joystick_ff_set_autocenter,
     unix_joystick_ff_set_gain,
+    unix_joystick_ff_send_cmd,
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     unix_joystick_create_effect,
 #else
@@ -1029,48 +1031,29 @@ static HRESULT WINAPI JoystickWImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W
 /*******************************************************************************
  *      SendForceFeedbackCommand - Send a command to the device's FF system
  */
-static HRESULT WINAPI JoystickWImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags)
+static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD flags)
 {
-    JoystickImpl* This = impl_from_IDirectInputDevice8W(iface);
-    TRACE("(this=%p,%d)\n", This, dwFlags);
+    JoystickImpl* This = impl_from_unix_joystick(ptr);
+
+    TRACE("(this=%p,%d)\n", This, flags);
 
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
-    switch (dwFlags)
+    switch (flags)
     {
     case DISFFC_STOPALL:
-    {
-        effect_list_item *itr;
-
-        /* Stop all effects */
-        LIST_FOR_EACH_ENTRY(itr, &This->generic.ff_effects, effect_list_item, entry)
-            IDirectInputEffect_Stop(itr->ref);
         break;
-    }
-
     case DISFFC_RESET:
-    {
-        effect_list_item *itr;
-
-        /* Stop and unload all effects. It is not true that effects are released */
-        LIST_FOR_EACH_ENTRY(itr, &This->generic.ff_effects, effect_list_item, entry)
-        {
-            IDirectInputEffect_Stop(itr->ref);
-            IDirectInputEffect_Unload(itr->ref);
-        }
         break;
-    }
     case DISFFC_PAUSE:
     case DISFFC_CONTINUE:
         FIXME("No support for Pause or Continue in linux\n");
         break;
-
     case DISFFC_SETACTUATORSOFF:
     case DISFFC_SETACTUATORSON:
         FIXME("No direct actuator control in linux\n");
         break;
-
     default:
-        WARN("Unknown Force Feedback Command %u!\n", dwFlags);
+        WARN("Unknown Force Feedback Command %u!\n", flags);
         return DIERR_INVALIDPARAM;
     }
     return DI_OK;
@@ -1103,7 +1086,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     JoystickWImpl_EnumEffects,
     JoystickWImpl_GetEffectInfo,
     JoystickWImpl_GetForceFeedbackState,
-    JoystickWImpl_SendForceFeedbackCommand,
+    JoystickWGenericImpl_SendForceFeedbackCommand,
     JoystickWGenericImpl_EnumCreatedEffectObjects,
     IDirectInputDevice2WImpl_Escape,
     JoystickWGenericImpl_Poll,
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 079063fd35f..c6779321673 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -944,6 +944,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
 
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value);
 static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value);
+static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD flags);
 
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *params,
         struct list *entry, IDirectInputEffect **out);
@@ -954,6 +955,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     NULL,
     unix_joystick_ff_set_autocenter,
     unix_joystick_ff_set_gain,
+    unix_joystick_ff_send_cmd,
     unix_joystick_create_effect,
     unix_joystick_poll,
 };
@@ -1386,10 +1388,9 @@ static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFG
     return S_OK;
 }
 
-static HRESULT WINAPI JoystickWImpl_SendForceFeedbackCommand(IDirectInputDevice8W *iface,
-        DWORD flags)
+static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD flags)
 {
-    JoystickImpl *This = impl_from_IDirectInputDevice8W(iface);
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
     HRESULT hr;
 
     TRACE("%p 0x%x\n", This, flags);
@@ -1437,7 +1438,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     IDirectInputDevice2WImpl_EnumEffects,
     IDirectInputDevice2WImpl_GetEffectInfo,
     IDirectInputDevice2WImpl_GetForceFeedbackState,
-    JoystickWImpl_SendForceFeedbackCommand,
+    JoystickWGenericImpl_SendForceFeedbackCommand,
     JoystickWGenericImpl_EnumCreatedEffectObjects,
     IDirectInputDevice2WImpl_Escape,
     JoystickWGenericImpl_Poll,
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 48ab9a42f38..3bc718a55ec 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -42,6 +42,7 @@ struct unix_joystick_vtbl
 
     HRESULT (CDECL *ff_set_autocenter)(struct unix_joystick *ptr, DWORD value);
     HRESULT (CDECL *ff_set_gain)(struct unix_joystick *ptr, DWORD value);
+    HRESULT (CDECL *ff_send_cmd)(struct unix_joystick *ptr, DWORD flags);
 
     HRESULT (CDECL *create_effect)(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect, struct list *entry, IDirectInputEffect **out);
 
@@ -95,6 +96,8 @@ HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, RE
 HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE8W iface,
         LPDIENUMCREATEDEFFECTOBJECTSCALLBACK lpCallback, LPVOID pvRef, DWORD dwFlags) DECLSPEC_HIDDEN;
 
+HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags) DECLSPEC_HIDDEN;
+
 HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface, DWORD len, LPVOID ptr) DECLSPEC_HIDDEN;
-- 
2.28.0

>From 7bbfaf68bf085ba0129c2a44c00bbb40292cc6a5 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 23:30:45 +0200
Subject: [PATCH 19/39] dinput: Use the unix vtable for GetForceFeedbackState.

---
 dlls/dinput/joystick.c            | 10 ++++++++++
 dlls/dinput/joystick_linux.c      |  1 +
 dlls/dinput/joystick_linuxinput.c | 15 ++++++++-------
 dlls/dinput/joystick_osx.c        |  1 +
 dlls/dinput/joystick_private.h    |  3 +++
 5 files changed, 23 insertions(+), 7 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 05ed7f8da3d..f1ec15aceee 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -779,6 +779,16 @@ HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE
     return DI_OK;
 }
 
+HRESULT WINAPI JoystickWGenericImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W iface, LPDWORD pdwOut)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+
+    TRACE("(this=%p,%p)\n", This, pdwOut);
+
+    if (!This->unix_funcs->ff_get_state) return DIERR_UNSUPPORTED;
+    return This->unix_funcs->ff_get_state(This->unix_ptr, pdwOut);
+}
+
 HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags)
 {
     JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 5220cb2cf5e..59d91117a94 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -146,6 +146,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     NULL,
     NULL,
     NULL,
+    NULL,
     unix_joystick_poll,
 };
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index d2075099ac0..a4d28415d17 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -162,6 +162,7 @@ static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value);
 static HRESULT CDECL unix_joystick_ff_set_gain(struct unix_joystick *ptr, DWORD value);
+static HRESULT CDECL unix_joystick_ff_get_state(struct unix_joystick *ptr, DWORD *state);
 static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD flags);
 
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
@@ -173,6 +174,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     unix_joystick_unacquire,
     unix_joystick_ff_set_autocenter,
     unix_joystick_ff_set_gain,
+    unix_joystick_ff_get_state,
     unix_joystick_ff_send_cmd,
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     unix_joystick_create_effect,
@@ -1011,18 +1013,17 @@ static HRESULT WINAPI JoystickWImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface,
 /*******************************************************************************
  *      GetForceFeedbackState - Get information about the device's FF state 
  */
-static HRESULT WINAPI JoystickWImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W iface, LPDWORD pdwOut)
+static HRESULT CDECL unix_joystick_ff_get_state(struct unix_joystick *ptr, DWORD *state)
 {
-    JoystickImpl* This = impl_from_IDirectInputDevice8W(iface);
+    JoystickImpl* This = impl_from_unix_joystick(ptr);
 
-    TRACE("(this=%p,%p)\n", This, pdwOut);
+    TRACE("(this=%p,%p)\n", This, state);
 
-    (*pdwOut) = 0;
+    (*state) = 0;
 
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
     /* DIGFFS_STOPPED is the only mandatory flag to report */
-    if (This->ff_state == FF_STATUS_STOPPED)
-	(*pdwOut) |= DIGFFS_STOPPED;
+    if (This->ff_state == FF_STATUS_STOPPED) (*state) |= DIGFFS_STOPPED;
 #endif
 
     return DI_OK;
@@ -1085,7 +1086,7 @@ static const IDirectInputDevice8WVtbl JoystickWvt =
     JoystickWGenericImpl_CreateEffect,
     JoystickWImpl_EnumEffects,
     JoystickWImpl_GetEffectInfo,
-    JoystickWImpl_GetForceFeedbackState,
+    JoystickWGenericImpl_GetForceFeedbackState,
     JoystickWGenericImpl_SendForceFeedbackCommand,
     JoystickWGenericImpl_EnumCreatedEffectObjects,
     IDirectInputDevice2WImpl_Escape,
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index c6779321673..56f9abb76a8 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -955,6 +955,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     NULL,
     unix_joystick_ff_set_autocenter,
     unix_joystick_ff_set_gain,
+    NULL,
     unix_joystick_ff_send_cmd,
     unix_joystick_create_effect,
     unix_joystick_poll,
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 3bc718a55ec..b8239438a2b 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -42,6 +42,7 @@ struct unix_joystick_vtbl
 
     HRESULT (CDECL *ff_set_autocenter)(struct unix_joystick *ptr, DWORD value);
     HRESULT (CDECL *ff_set_gain)(struct unix_joystick *ptr, DWORD value);
+    HRESULT (CDECL *ff_get_state)(struct unix_joystick *ptr, DWORD *state);
     HRESULT (CDECL *ff_send_cmd)(struct unix_joystick *ptr, DWORD flags);
 
     HRESULT (CDECL *create_effect)(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect, struct list *entry, IDirectInputEffect **out);
@@ -96,6 +97,8 @@ HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, RE
 HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE8W iface,
         LPDIENUMCREATEDEFFECTOBJECTSCALLBACK lpCallback, LPVOID pvRef, DWORD dwFlags) DECLSPEC_HIDDEN;
 
+HRESULT WINAPI JoystickWGenericImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W iface, LPDWORD pdwOut) DECLSPEC_HIDDEN;
+
 HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags) DECLSPEC_HIDDEN;
 
 HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
-- 
2.28.0

>From 797345a7b5eda23bda94420d4c0bd7206102c24f Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 23:32:33 +0200
Subject: [PATCH 20/39] dinput: Use the unix vtable for GetEffectInfo.

---
 dlls/dinput/effect_linuxinput.c   | 35 -------------------------------
 dlls/dinput/joystick.c            | 21 +++++++++++++++++++
 dlls/dinput/joystick_linux.c      |  1 +
 dlls/dinput/joystick_linuxinput.c | 15 +++++++------
 dlls/dinput/joystick_osx.c        |  1 +
 dlls/dinput/joystick_private.h    |  3 +++
 6 files changed, 33 insertions(+), 43 deletions(-)

diff --git a/dlls/dinput/effect_linuxinput.c b/dlls/dinput/effect_linuxinput.c
index ec4b00b873a..d5daba6daa1 100644
--- a/dlls/dinput/effect_linuxinput.c
+++ b/dlls/dinput/effect_linuxinput.c
@@ -886,41 +886,6 @@ DECLSPEC_HIDDEN HRESULT linuxinput_get_info_A(
     return DI_OK;
 }
 
-DECLSPEC_HIDDEN HRESULT linuxinput_get_info_W(
-	int fd,
-	REFGUID rguid,
-	LPDIEFFECTINFOW info)
-{
-    DWORD type = typeFromGUID(rguid);
-
-    TRACE("(%d, %s, %p) type=%d\n", fd, _dump_dinput_GUID(rguid), info, type);
-
-    if (!info) return E_POINTER;
-
-    if (info->dwSize != sizeof(DIEFFECTINFOW)) return DIERR_INVALIDPARAM;
-
-    info->guid = *rguid;
-
-    info->dwEffType = type;
-    /* the event device API does not support querying for all these things
-     * therefore we assume that we have support for them
-     * that's not as dangerous as it sounds, since drivers are allowed to
-     * ignore parameters they claim to support anyway */
-    info->dwEffType |= DIEFT_DEADBAND | DIEFT_FFATTACK | DIEFT_FFFADE
-                    | DIEFT_POSNEGCOEFFICIENTS | DIEFT_POSNEGSATURATION
-                    | DIEFT_SATURATION | DIEFT_STARTDELAY; 
-
-    /* again, assume we have support for everything */
-    info->dwStaticParams = DIEP_ALLPARAMS;
-    info->dwDynamicParams = info->dwStaticParams;
-
-    /* yes, this is windows behavior (print the GUID_Name for name) */
-    MultiByteToWideChar(CP_ACP, 0, _dump_dinput_GUID(rguid), -1, 
-                        info->tszName, MAX_PATH);
-
-    return DI_OK;
-}
-
 static const IDirectInputEffectVtbl LinuxInputEffectVtbl = {
     LinuxInputEffectImpl_QueryInterface,
     LinuxInputEffectImpl_AddRef,
diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index f1ec15aceee..6d36bdbbbe8 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -739,6 +739,27 @@ HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REF
     return DI_OK;
 }
 
+static void dieffectinfo_atow(const DIEFFECTINFOA *dieia, DIEFFECTINFOW *dieiw)
+{
+    dieiw->guid = dieia->guid;
+    dieiw->dwEffType = dieia->dwEffType;
+    dieiw->dwStaticParams = dieia->dwStaticParams;
+    dieiw->dwDynamicParams = dieia->dwDynamicParams;
+    MultiByteToWideChar(CP_ACP, 0, dieia->tszName, -1, dieiw->tszName, sizeof(dieiw->tszName));
+}
+
+HRESULT WINAPI JoystickWGenericImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface, LPDIEFFECTINFOW diei, REFGUID rguid)
+{
+    JoystickGenericImpl *This = impl_from_IDirectInputDevice8W(iface);
+    DIEFFECTINFOA dieia = {sizeof(dieia)};
+    HRESULT hr;
+    TRACE("(this=%p,%p,%s)\n", This, diei, debugstr_guid(rguid));
+    if (!This->unix_funcs->get_effect_info) return DIERR_UNSUPPORTED;
+    hr = This->unix_funcs->get_effect_info(This->unix_ptr, rguid, &dieia);
+    dieffectinfo_atow(&dieia, diei);
+    return hr;
+}
+
 HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIEFFECT lpeff,
         LPDIRECTINPUTEFFECT *ppdef, LPUNKNOWN pUnkOuter)
 {
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index 59d91117a94..d8611d72774 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -147,6 +147,7 @@ static const struct unix_joystick_vtbl unix_joystick_vtbl =
     NULL,
     NULL,
     NULL,
+    NULL,
     unix_joystick_poll,
 };
 
